diff --git a/tests/fsck-tests/018-leaf-accross-stripes/default_case.raw.xz b/tests/fsck-tests/018-leaf-accross-stripes/default_case.raw.xz
new file mode 100644
index 0000000000000000000000000000000000000000..60eb2f978a4c37b000b650ddcb06219eadac9e68
GIT binary patch
diff --git a/tests/fsck-tests/018-leaf-accross-stripes/test.sh b/tests/fsck-tests/018-leaf-accross-stripes/test.sh
new file mode 100755
index 0000000..7e7f8c5
--- /dev/null
+++ b/tests/fsck-tests/018-leaf-accross-stripes/test.sh
@@ -0,0 +1,12 @@
+#!/bin/bash
+
+source $TOP/tests/common
+
+check_prereq btrfs
+
+extract_image "./default_case.raw.xz"
+$TOP/btrfs check "$EXTRACT_IMAGE_OUTPUT" 2>&1 |
+	grep -q "crossing stripe boundary" ||
+	_fail "no expected error message in output"
+
+rm -f "$EXTRACT_IMAGE_OUTPUT"